﻿using Infragistics.UltraChart.Core.Primitives;
using Infragistics.UltraChart.Data;
using Infragistics.UltraChart.Shared.Events;
using Infragistics.UltraChart.Shared.Styles;
using Infragistics.Win.UltraWinChart;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace GanttWithMinWidth
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            UltraChart ch = new UltraChart() { Dock = DockStyle.Fill, ChartType = ChartType.GanttChart };
            GanttDataSource data = new GanttDataSource();
            data.Series.Add(new GanttSeries());
            data.Series[0].Items.Add(new GanttItem());
            data.Series[0].Items[0].Times.Add(DateTime.Today, DateTime.Today.AddDays(1));
            data.Series[0].Items.Add(new GanttItem());
            data.Series[0].Items[1].Times.Add(DateTime.Today.AddDays(2), DateTime.Today.AddDays(2).AddMilliseconds(1));
            data.Series[0].Items.Add(new GanttItem());
            data.Series[0].Items[2].Times.Add(DateTime.Today.AddDays(3), DateTime.Today.AddDays(4));
            ch.Data.DataSource = data;
            this.Controls.Add(ch);

            ch.FillSceneGraph += Ch_FillSceneGraph;
        }

        private void Ch_FillSceneGraph(object sender, FillSceneGraphEventArgs e)
        {
            IEnumerable<Box> sceneBoxes = e.SceneGraph.OfType<Box>();
            IEnumerable<Box> zeroWidthGanttBoxes = sceneBoxes.Where((box) => box.Chart == ChartType.GanttChart && box.rect.Width == 0);
            IEnumerable<Line> linesToAdd = zeroWidthGanttBoxes.Select((box) => new Line(new Point(box.rect.Left, box.rect.Top), new Point(box.rect.Right, box.rect.Bottom)));
            e.SceneGraph.AddRange(linesToAdd.ToArray());
        }
    }
}
